# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from hri_msgs/EngagementLevel.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class EngagementLevel(genpy.Message):
  _md5sum = "adde9558b582c345b7a2511ccaee7770"
  _type = "hri_msgs/EngagementLevel"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Discrete engagement levels of a person with respect to the robot
# It is for instance published on /humans/persons/person_id/engagement_status 
# to access to the engagement level of a detected human. 
# It will output one of the five following levels: unknown, disengaged, 
# engaging, engaged and disengaging.
  
# unknown: no information is provided about the engagement level 
uint8 UNKNOWN=0
# disengaged: the human has not looked in the direction of the robot
uint8 DISENGAGED=1
# engaging: the human has started to look in the direction of the robot
uint8 ENGAGING=2
# engaged: the human is fully engaged with the robot
uint8 ENGAGED=3
# disengaging: the human has started to look away from the robot
uint8 DISENGAGING=4

uint8 level

"""
  # Pseudo-constants
  UNKNOWN = 0
  DISENGAGED = 1
  ENGAGING = 2
  ENGAGED = 3
  DISENGAGING = 4

  __slots__ = ['level']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       level

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EngagementLevel, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.level is None:
        self.level = 0
    else:
      self.level = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.level
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.level,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.level
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.level,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
